"use strict";

function CloseCalculation()
{
    document.getElementById("configfld").classList.replace("flexcont", "none");
    document.getElementById("outputfld").classList.replace("flexcont", "none");
    document.getElementById("calcresultfld").classList.replace("flexcont", "none");
    document.getElementById("run").classList.add("disable");
    EnableEditAccuracy(false);
    EnableEditFiltPlot(false);
    SPGUI.currCalcType = "";
}

function EnableEditAccuracy(isenable)
{
    if(isenable){
        document.getElementById(EditAccuracy).setAttribute("tabindex", "-1");
        document.getElementById(EditAccuracy).classList.remove("disable");    
    }
    else{
        document.getElementById(EditAccuracy).removeAttribute("tabindex");
        document.getElementById(EditAccuracy).classList.add("disable");    
    }
}

function EnableEditFiltPlot(isenable)
{
    if(isenable){
        document.getElementById(EditFiltPlotConfig).setAttribute("tabindex", "-1");
        document.getElementById(EditFiltPlotConfig).classList.remove("disable");    
    }
    else{
        document.getElementById(EditFiltPlotConfig).removeAttribute("tabindex");
        document.getElementById(EditFiltPlotConfig).classList.add("disable");    
    }
}

function ArrangeSpJSON(spjson)
{
    if(spjson.hasOwnProperty(BLLabel)){
        return spjson;
    }

    let blobj = {}, accobj = {}, srcobj = {}, confobj = {};
    blobj[SPGUI.setting.prmfile] = 
    {
        [AccLabel]:SPGUI.setting.prmfile,
        [SrcLabel]:SPGUI.setting.prmfile,
        [ConfigLabel]:SPGUI.setting.prmfile
    };

    accobj[SPGUI.setting.prmfile] = CopyJSON(def_acc);
    srcobj[SPGUI.setting.prmfile] = CopyJSON(def_src);
    confobj[SPGUI.setting.prmfile] = CopyJSON(def_conf);

    Object.assign(accobj[SPGUI.setting.prmfile], spjson[AccLabel]);
    Object.assign(srcobj[SPGUI.setting.prmfile], spjson[SrcLabel]);
    Object.assign(confobj[SPGUI.setting.prmfile], spjson[ConfigLabel]);

    let obj = {
        [CurrentLabel]:SPGUI.setting.prmfile,
        [BLLabel]:blobj,
        [AccLabel]:accobj,
        [SrcLabel]:srcobj,
        [ConfigLabel]:confobj
    };
    if(spjson.hasOwnProperty(FMaterialLabel)){
        obj[FMaterialLabel] = spjson[FMaterialLabel];
    }
    return obj;
}

function FreezeGUI(isfreeze, isconf, isout, isfel)
{
    SPGUI.acctbl.DisableTable(isfreeze);
    SPGUI.accopt.DisableOptions(isfreeze);
    SPGUI.srctbl.DisableTable(isfreeze);
    SPGUI.srcopt.DisableOptions(isfreeze);
    if(isconf){
        SPGUI.conftbl.DisableTable(isfreeze);
    }
    if(isout){
        SPGUI.outputopt.ForceFormatJSON(isfreeze);
    }
    if(isfel){
        SPGUI.configFELtbl.DisableTable(isfreeze);
    }
    if(isfreeze){
        document.getElementById("acctype").setAttribute("disabled", true);
        document.getElementById("srctype").setAttribute("disabled", true);
    }
    else{
        document.getElementById("acctype").removeAttribute("disabled");
        document.getElementById("srctype").removeAttribute("disabled");
    }
}

function RestoreOriginal()
{
    let calcid = GetObj(ConfigLabel)[TypeLabel];
    let confopt = CopyJSON(GetObj(ConfigLabel)[OptionLabel]);
    if(SPGUI.orginobj != ""){
        SPGUI.curr_spjson = CopyJSON(ArrangeSpJSON(SPGUI.orginobj[InputLabel]));
        AppendDefault(SPGUI.curr_spjson);
        GetObj(ConfigLabel)[OptionLabel] = confopt;
        GetObj(ConfigLabel)[TypeLabel] = calcid;
        LoadJSON(true);
    }
}

function IsFELReuse(calcid)
{
    let isfelreuse = 
        calcid.indexOf(MenuLabels.cohrad) >= 0 && 
        SPGUI.confopt.IsShown(ConfigOptionsLabel.fel[0]) &&
        GetObj(ConfigLabel)[OptionLabel][ConfigOptionsLabel.fel[0]] == FELReuseLabel;
    return isfelreuse;
}

function SelectCalculation(evt)
{
    SPGUI.caclresultgrid.GetTable().innerHTML = "";
    GetObj(ConfigLabel)[TypeLabel] = evt.currentTarget.id;
    SPGUI.currCalcType = evt.currentTarget.id;

    let iscmd = evt.currentTarget.id.indexOf(MenuLabels.CMD) >= 0;

    if(iscmd){
        RestoreOriginal();
    }
    else{
        LoadAccOption();
        LoadSrcOption();
        LoadConfig(true);
        SwitchFELRelated();    
    }

    if(IsFELReuse(evt.currentTarget.id)){
        FreezeGUI(true, false, false, true);
    }
    else{
        FreezeGUI(iscmd, true, true, false);
    }
    document.getElementById("configfld").classList.replace("none", "flexcont");
    document.getElementById("run").classList.remove("disable");
}

function SetCalcId3DField()
{
    let near_sp = GetIDFromItem(MenuLabels.near, MenuLabels.spatial, -1);
    SPGUI.disabledcalcid.push(MenuLabels.far);
    SPGUI.disabledcalcid.push(GetIDFromItem(near_sp, MenuLabels.vpdens, -1));
    SPGUI.disabledcalcid.push(GetIDFromItem(MenuLabels.fixed, MenuLabels.far, -1));
    let wigner = GetIDFromItem(MenuLabels.srcpoint, MenuLabels.wigner, -1);
    SPGUI.disabledcalcid.push(GetIDFromItem(wigner, MenuLabels.Kvalue, -1));
}

function SetDisableCalcIDs(accobj, srcobj)
{
    let near_sp = GetIDFromItem(MenuLabels.near, MenuLabels.spatial, -1);
    let far_simp = GetIDFromItem(MenuLabels.far, 
            GetIDFromItem(MenuLabels.energy, MenuLabels.simpcalc, -1), -1);
    let far_sp = GetIDFromItem(MenuLabels.far, MenuLabels.spatial, -1);
    let src_wig = GetIDFromItem(MenuLabels.srcpoint, MenuLabels.wigner, -1);
    let src_wigK =  GetIDFromItem(src_wig, MenuLabels.Kvalue, -1);
    let far_K = GetIDFromItem(MenuLabels.far, MenuLabels.Kvalue, -1);
    
    let bunchtype = accobj[OptionLabel][AccOptionsLabel.bunchtype[0]];
    if(Is3DField(srcobj) || bunchtype == ImportPaticleLabel){
        SetCalcId3DField();
    }

    let isseg = srcobj[OptionLabel][SrcOptionsLabel.segment_type[0]] != NoneLabel;
    if(isseg){
        SPGUI.disabledcalcid.push(GetIDFromItem(far_sp, MenuLabels.pdensr, -1));
    }

    let srctype = srcobj[TypeLabel];
    if(srctype == SrcTypeLabel.CUSTOM){
        SPGUI.disabledcalcid.push(MenuLabels.far);
        SPGUI.disabledcalcid.push(GetIDFromItem(MenuLabels.fixed, MenuLabels.far, -1));
        SPGUI.disabledcalcid.push(src_wigK);
    }
    else if(srctype == SrcTypeLabel.WLEN_SHIFTER)
    {
        SPGUI.disabledcalcid.push(MenuLabels.far);
        SPGUI.disabledcalcid.push(MenuLabels.srcpoint);
        SPGUI.disabledcalcid.push(MenuLabels.cohrad);

        if(srctype == SrcTypeLabel.FIELDMAP3D){
            SPGUI.disabledcalcid.push(GetIDFromItem(near_sp, MenuLabels.spdens, -1));
            SPGUI.disabledcalcid.push(GetIDFromItem(near_sp, MenuLabels.vpdens, -1));
        }

        SPGUI.disabledcalcid.push(GetIDFromItem(MenuLabels.fixed, MenuLabels.far, -1));
        SPGUI.disabledcalcid.push(GetIDFromItem(MenuLabels.fixed, MenuLabels.cohrad, -1));
        SPGUI.disabledcalcid.push(GetIDFromItem(MenuLabels.fixed, MenuLabels.wigner, -1));
        let fixed_near = GetIDFromItem(MenuLabels.fixed, MenuLabels.near, -1);
        if(srctype == SrcTypeLabel.FIELDMAP3D){
            SPGUI.disabledcalcid.push(GetIDFromItem(fixed_near, MenuLabels.spdens, -1));
        }
    }
    else if(srctype == SrcTypeLabel.BM){
        SPGUI.disabledcalcid.push(src_wigK);
        SPGUI.disabledcalcid.push(GetIDFromItem(far_sp, MenuLabels.pdensr, -1));
        let far_sp_flux = GetIDFromItem(far_sp, MenuLabels.fdensa, -1);
        let far_sp_power = GetIDFromItem(far_sp, MenuLabels.pdensa, -1);
        SPGUI.disabledcalcid.push(far_K);
        SPGUI.disabledcalcid.push(GetIDFromItem(far_sp_flux, MenuLabels.meshxy, -1));
        SPGUI.disabledcalcid.push(GetIDFromItem(far_sp_flux, MenuLabels.meshrphi, -1));
        SPGUI.disabledcalcid.push(GetIDFromItem(far_sp_power, MenuLabels.meshxy, -1));
        SPGUI.disabledcalcid.push(GetIDFromItem(far_sp_power, MenuLabels.meshrphi, -1));
        if(srcobj[OptionLabel][SrcOptionsLabel.bmtandem[0]]){
            SPGUI.disabledcalcid.push(MenuLabels.far);
        }
    }
    else if(srctype == SrcTypeLabel.WIGGLER || srctype == SrcTypeLabel.EMPW){
        SPGUI.disabledcalcid.push(src_wigK);
        SPGUI.disabledcalcid.push(GetIDFromItem(far_sp, MenuLabels.pdensr, -1));
        SPGUI.disabledcalcid.push(far_K);
        SPGUI.disabledcalcid.push(GetIDFromItem(MenuLabels.near, MenuLabels.energy, -1));
        SPGUI.disabledcalcid.push(GetIDFromItem(near_sp, MenuLabels.fdenss, -1));
        SPGUI.disabledcalcid.push(GetIDFromItem(near_sp, MenuLabels.vpdens, -1));
        SPGUI.disabledcalcid.push(MenuLabels.cohrad);
        let fixnear = GetIDFromItem(MenuLabels.fixed, MenuLabels.near, -1);
        SPGUI.disabledcalcid.push(GetIDFromItem(fixnear, MenuLabels.fdenss, -1));
        SPGUI.disabledcalcid.push(GetIDFromItem(fixnear, MenuLabels.pflux, -1));
        SPGUI.disabledcalcid.push(GetIDFromItem(MenuLabels.fixed, MenuLabels.cohrad, -1));
        SPGUI.disabledcalcid.push(GetIDFromItem(MenuLabels.fixed, MenuLabels.wigner, -1));
    }
    else if(srctype == SrcTypeLabel.CUSTOM_PERIODIC){
        SPGUI.disabledcalcid.push(far_simp);
        SPGUI.disabledcalcid.push(far_K);
        SPGUI.disabledcalcid.push(src_wigK);
    }
    else{
        SPGUI.disabledcalcid.push(far_simp);
        if(isseg){
            SPGUI.disabledcalcid.push(GetIDFromItem(far_K, MenuLabels.simpcalc, -1));
            SPGUI.disabledcalcid.push(src_wigK);
        }
        if(srcobj[OptionLabel][SrcOptionsLabel.fielderr[0]] || 
                srcobj[OptionLabel][SrcOptionsLabel.phaseerr[0]]){
            SPGUI.disabledcalcid.push(MenuLabels.far);
            SPGUI.disabledcalcid.push(src_wigK);
        }
    }

    let cmdcont = Output4CMD(SPGUI.orginobj);
    if(!cmdcont.wigner){
        SPGUI.disabledcalcid.push(MenuLabels.CMD);
    }
    else if(!cmdcont.result){
        SPGUI.disabledcalcid.push(GetIDFromItem(MenuLabels.CMD, MenuLabels.CMDPP, -1));
    }
    if(cmdcont.result){
        let obj = GetObj(ConfigLabel)[OptionLabel][ConfigOptionsLabel.CMDprms[0]];
        let maxorder = SPGUI.orginobj[CMDResultLabel][MaxOrderLabel];
        if(Array.isArray(maxorder)){
            obj[CMDPrmsLabel.maxHGorderxy] = Array.from(maxorder);
        }
        else{
            obj[CMDPrmsLabel.maxHGorderx] = obj[CMDPrmsLabel.maxHGordery[0]] = maxorder;
        }    
    }
}

function SwitchCalcID(accobj, srcobj)
{
    for(let i = 0; i < SPGUI.disabledcalcid.length; i++){
        document.getElementById(SPGUI.disabledcalcid[i]).setAttribute("tabindex", "-1");
        document.getElementById(SPGUI.disabledcalcid[i]).classList.remove("disable");
    }
    SPGUI.disabledcalcid.length = 0;

    SetDisableCalcIDs(accobj, srcobj);

    for(let i = 0; i < SPGUI.disabledcalcid.length; i++){
        document.getElementById(SPGUI.disabledcalcid[i]).removeAttribute("tabindex");
        document.getElementById(SPGUI.disabledcalcid[i]).classList.add("disable");
    }
}

function ReviseFilterMaterial()
{
    let materials = SPGUI.filtermaterials.GetMaterialNames();
    let id = GetIDFromItem(ConfigLabel, ConfigOptionsLabel.fmateri[0]);
    SPGUI.sprdsheetcol[id] = {
        coltypes:[
            {ColLabel:"Material", ColType:materials},
            {ColLabel:"Thickness (mm)", ColType:"number"}
        ],
        withnum:false
    };

    id = GetIDFromItem(ConfigLabel, ConfigOptionsLabel.amateri[0]);
    SPGUI.sprdsheetcol[id] = {
        coltypes:[
            {ColLabel:"Material", ColType:materials},
            {ColLabel:"Thickness (mm)", ColType:"number"}
        ],
        withnum:false
    };
}

function AddRemoveOption(select, value, label, isadd)
{
    let childs = select.childNodes;
    for(let i = 0; i < childs.length; i++){
        if(childs[i].value == value){
            if(!isadd){
                select.removeChild(childs[i]);
            }
            return;
        }
    }
    if(!isadd){
        return;
    }
    let option = document.createElement("option")
    option.value = value;
    option.innerHTML = label;
    select.appendChild(option);
}

function UpdateAllPlots(items)
{
    if(typeof items == "undefined"){
        return;
    }
    let seldata = document.getElementById("dataselect");
    let currval = seldata.value;
    let isupdate = false;

    let isitem = false;
    for(let n = 0; n < items.length; n++){
        if(items[n].isshow){
            isitem = true;
            break;
        }
    }
    let childs = seldata.childNodes;
    let isgrp = false;
    let optgrp;
    for(let n = 0; n < childs.length; n++){
        if(childs[n].label == PPDataImpLabel){
            optgrp = childs[n];
            isgrp = true;
            break;
        }
    }
    if(isitem && !isgrp){
        optgrp = document.createElement("optgroup");
        optgrp.label = PPDataImpLabel;
        seldata.appendChild(optgrp);
    }

    for(let n = 0; n < items.length; n++){
        let value = AttachSuffix(items[n].id, SuffixPlotBody);
        let item = GetItemFromID(items[n].id);
        let label = item.categ+" - "+item.item;
        if(value == currval){
            isupdate = true;
        }
        AddRemoveOption(seldata, value, label, items[n].isshow);
    }

    if(seldata.options.length == DefaultPPItems && isgrp){
        seldata.removeChild(optgrp);
    }

    SetSelection(seldata, currval, true);
    if(seldata.selectedIndex < 0){
        ClearDataPlot();
    }
    else{
        if(isupdate){
            let id = DetachSuffix(currval, SuffixPlotBody);
            SPGUI.importdata[id].UpdatePlot(false);
        }
    }
}

function ShowPreProcessItems(prmobj)
{
    let seldata = document.getElementById("dataselect");
    for(let j = 0; j < seldata.options.length; j++){
        if(seldata.options[j].innerHTML == prmobj.item){
            if(prmobj.enable){
                seldata.options[j].removeAttribute("disabled");
            }
            else{
                seldata.options[j].setAttribute("disabled", true);
            }
        }
    }
}

function GetCurrentCalcID()
{
    let calcid = "";
    if(GetObj(ConfigLabel).hasOwnProperty(TypeLabel)){
        calcid = GetObj(ConfigLabel)[TypeLabel];
    }
    if(SPGUI.currCalcType != "" && SPGUI.disabledcalcid.indexOf(SPGUI.currCalcType) < 0){
        let isok = true;
        let types = SPGUI.currCalcType.split(IDSeparator);
        do {
            let calc = types.join(IDSeparator);
            if(SPGUI.disabledcalcid.indexOf(calc) >= 0){
                isok = false;
                break;
            }
            types.pop();
        } while(types.length > 0);
        if(isok){
            calcid = SPGUI.currCalcType;
        }
    }
    SPGUI.currCalcType = calcid;            
    return calcid;
}

function LoadJSON(skipcalc = false)
{   
    SPGUI.gapfieldtable.SetSrcObj(GetObj(SrcLabel));
    
    // update filter materials
    if(SPGUI.curr_spjson.hasOwnProperty(FMaterialLabel) == false){
        SPGUI.curr_spjson[FMaterialLabel] = {};
    }
    SPGUI.filtermaterials = new EditFilterMaterial("fmat", 
            FilterMaterial, SPGUI.curr_spjson[FMaterialLabel]);

    document.getElementById("fmaterialDialog").innerHTML = "";
    let fmdiv = document.createElement("div");
    fmdiv.className = "flexcont flexcolumn";
    fmdiv.style.alignItems = "flex-end";
    document.getElementById("fmaterialDialog").appendChild(fmdiv);
    fmdiv.appendChild(SPGUI.filtermaterials.GetTable());
    let fmcls = document.createElement("button");
    fmcls.innerHTML = "OK";
    fmdiv.appendChild(fmcls);
    fmcls.addEventListener("click", (e) => {
        document.getElementById("fmaterialDialog").close();
        ReviseFilterMaterial();
        let indices = LoadConfig(true);
        RefreshGUIPrms(indices);
        e.stopPropagation();
    });
    
    ReviseFilterMaterial();

    // update parameters and options
    LoadAcc(false);
    LoadSrc(false);
    LoadConfig(false);
    LoadAccOption();
    LoadSrcOption();

    // update magnet configuration
    SPGUI.srcmagconftbl.JSONObj = 
        GetObj(SrcLabel)[OptionLabel][SrcOptionsLabel.magconf[0]];
    SPGUI.srcmagconftbl.SetPrmTypes();
    UpdatePrms(ALL_UPDATE);

    if(!skipcalc){
        CloseCalculation();
        let calcid = GetCurrentCalcID();
        if(calcid != ""){
            let evt = {};
            evt.currentTarget = {id:calcid};
            SelectCalculation(evt);
        }    
    }
    SwitchFELRelated();
}

function SwitchFELReuse()
{
    let isbfreuse = IsFELBunchFactor(SPGUI.orginobj);
    if(typeof isbfreuse != "boolean"){
        isbfreuse = false;        
    }
    SPGUI.confopt.DisableSelection(ConfigOptionsLabel.fel[0], FELReuseLabel, isbfreuse == false);    
}

function SwitchFELRelated()
{
    let isfel = false;
    if(GetObj(ConfigLabel)[TypeLabel] != ""){
        isfel = SPGUI.confopt.IsShown(ConfigOptionsLabel.fel[0]) && 
            GetObj(ConfigLabel)[OptionLabel][ConfigOptionsLabel.fel[0]] != NoneLabel && 
            GetObj(ConfigLabel)[OptionLabel][ConfigOptionsLabel.fel[0]] != FELReuseLabel;
    }
    SPGUI.accopt.DisableSelection(AccOptionsLabel.bunchtype[0], ImportPaticleLabel, isfel);
}

function LoadAccOption()
{
    document.getElementById("acc_option").innerHTML = "";

    let accobj = GetObj(AccLabel);
    let srcobj = GetObj(SrcLabel);
    let confobj = GetObj(ConfigLabel);

    let accopttypes = AccOptTypes(accobj, srcobj, confobj);
    
    let tbllist = {[AccOptionsLabel.injecprm[0]]:SPGUI.injtbl};
    let prmtypes = {[AccOptionsLabel.injecprm[0]]:InjectionPrmTypes()};
    SPGUI.accopt.JSONObj = GetObj(AccLabel);
    SPGUI.accopt.SetValidity(accopttypes, tbllist, prmtypes);
    document.getElementById("acc_option").appendChild(SPGUI.accopt.GetTable());

    let labels = [AccOptionsLabel.currdata[0], AccOptionsLabel.Etdata[0]];
    let items = [];
    for(let n = 0; n < labels.length; n++){
        items.push({id:GetIDFromItem(AccLabel, labels[n]), 
            isshow:accopttypes[labels[n]]})
    }
    UpdateAllPlots(items);
    SwitchCalcID(accobj, srcobj);
}

function LoadSrcOption()
{
    document.getElementById("src_option").innerHTML = "";

    let accobj = GetObj(AccLabel);
    let srcobj = GetObj(SrcLabel);
    let calcid = GetCurrentCalcID();
    let srcopttypes = SrcOptTypes(accobj, srcobj, calcid);

    let ferr = SrcOptionsLabel.fielderr[0];
    let perr = SrcOptionsLabel.phaseerr[0];
    let enable = (srcopttypes[ferr] && srcobj[OptionLabel][ferr]) 
        || (srcopttypes[perr] && srcobj[OptionLabel][perr])
        || srcobj[TypeLabel] == SrcTypeLabel.CUSTOM;
    let prmobj = {item:PPPhaseErrLabel, enable:enable};
    ShowPreProcessItems(prmobj)
    prmobj = {item:PPRedFlux, enable:enable};
    ShowPreProcessItems(prmobj)
            
    let keyferr = SrcOptionsLabel.ferrprm[0];
    let keyperr = SrcOptionsLabel.perrprm[0];
    let keyseg = SrcOptionsLabel.segprm[0];
    let tbllist = {[keyferr]:SPGUI.srcferrtbl, [keyperr]:SPGUI.srcperrtbl, [keyseg]:SPGUI.srcsegtbl};
    let prmtypes = {[keyferr]:FerrPrmTypes(), [keyperr]:PerrPrmTypes(), [keyseg]:SegPrmTypes(srcobj)};
    SPGUI.srcopt.JSONObj = srcobj;
    SPGUI.srcopt.SetValidity(srcopttypes, tbllist, prmtypes);
    document.getElementById("src_option").appendChild(SPGUI.srcopt.GetTable());

    let labels = [SrcOptionsLabel.gaptbl[0]];
    let items = [];
    for(let n = 0; n < labels.length; n++){
        items.push({id:GetIDFromItem(SrcLabel, labels[n]), 
            isshow:srcopttypes[labels[n]]})
    }
    UpdateAllPlots(items);
    SwitchCalcID(accobj, srcobj);
}

function LoadAcc(isupdate)
{
    let issrc = false, isconf =false;

    let indices = [];
    if(isupdate){
        let id = GetIDFromItem(AccLabel, ALL_UPDATE, -1);
        indices = UpdateAcc(id);
        for(let i = 0; i < indices.length; i++){
            if(indices[i].indexOf(SrcLabel) >= 0){
                issrc = true;
            }
            if(indices[i].indexOf(ConfigLabel) >= 0){
                isconf = true;
            }
        }    
    }

    document.getElementById("acc").innerHTML = "";
    let accobj = GetObj(AccLabel);
    let accprmtypes = {};
    accprmtypes = AccPrmTypes(accobj[TypeLabel], 
            accobj[OptionLabel][AccOptionsLabel.bunchtype[0]]);
    SPGUI.acctbl.JSONObj = accobj;
    SPGUI.acctbl.SetPrmTypes(accprmtypes);
    document.getElementById("acc").appendChild(SPGUI.acctbl.GetTable());

    let acctype = document.getElementById("acctype");
    SetSelection(acctype, accobj[TypeLabel], false);

    return {issrc:issrc, isconf:isconf, update:indices};
}

function LoadSrc(isupdate)
{
    let indices = [];
    if(isupdate){
        let id = GetIDFromItem(SrcLabel, ALL_UPDATE, -1);
        indices = UpdateLightSrc(id);    
    }
    document.getElementById("src").innerHTML = "";
    let srcobj = GetObj(SrcLabel);
    let accobj = GetObj(AccLabel);
    let srcprmtypes = {};
    let srccont = GetSrcContents(srcobj);
    srcprmtypes = SrcPrmTypes(accobj, srcobj, srccont);

    SPGUI.srctbl.JSONObj = srcobj;
    SPGUI.srctbl.SetPrmTypes(srcprmtypes);
    document.getElementById("src").appendChild(SPGUI.srctbl.GetTable());

    let labels = [SrcPrmsLabel.fvsz, SrcPrmsLabel.fvsz1per];
    let items = [];
    for(let n = 0; n < labels.length; n++){
        let isshow = srcprmtypes[labels[n]] == PlotObjLabel;
        items.push({id:GetIDFromItem(SrcLabel, labels[n]), isshow:isshow})
    }
    UpdateAllPlots(items);

    let srctype = document.getElementById("srctype");
    SetSelection(srctype, srcobj[TypeLabel], false);
    return indices;
}

function LoadConfig(isupdate)
{
    let indices = [];
    if(isupdate){
        let id = GetIDFromItem(ConfigLabel, ALL_UPDATE, -1);
        indices = UpdateConfig(id);    
    }

    let accobj = GetObj(AccLabel);
    let confobj = GetObj(ConfigLabel);
    let srcobj = GetObj(SrcLabel);
    let conftypes = ConfigPrmOptTypes(accobj, srcobj, confobj);

    let filterl = ConfigOptionsLabel.filter[0];
    let enablef = false;
    if(conftypes[1].hasOwnProperty(filterl)){
        enablef = conftypes[1][filterl] && confobj[OptionLabel][filterl] != NoneLabel;
    }
    let prmobj = {item:PPTransLabel, enable:enablef};
    ShowPreProcessItems(prmobj)

    let enablea = false;
    if(confobj.hasOwnProperty(TypeLabel)){
        enablea = confobj[TypeLabel].indexOf(MenuLabels.vpdens) >= 0;
    }
    prmobj = {item:PPAbsLabel, enable:enablea};
    ShowPreProcessItems(prmobj)

    document.getElementById("config").innerHTML = "";
    SPGUI.conftbl.JSONObj = confobj;
    SPGUI.conftbl.SetPrmTypes(conftypes[0]);

    let calctypediv = document.createElement("div");
    calctypediv.className = "flexcont";
    let calctylelabel = document.createElement("div");
    calctylelabel.style.whiteSpace = "normal";
    calctylelabel.style.wordBreak = "break-all";
    calctylelabel.style.width = "180px";
    calctylelabel.style.color = "#111";
    calctylelabel.innerHTML = confobj[TypeLabel];
    calctylelabel.className = "flexgrow";
    calctypediv.appendChild(calctylelabel);

    calctypediv.style.margin = "0 0 5px 0";
    calctypediv.style.border = "ridge";
    calctypediv.style.backgroundColor = "white";
    document.getElementById("config").appendChild(calctypediv);

    document.getElementById("config").appendChild(SPGUI.conftbl.GetTable());
    document.getElementById("config_option").innerHTML = "";

    let keybpf = ConfigOptionsLabel.bpfprms[0];
    let keycmd = ConfigOptionsLabel.CMDprms[0];
    let keyfel = ConfigOptionsLabel.FELprms[0];
    let tbllist = {[keybpf]:SPGUI.configbpftbl, [keycmd]:SPGUI.configCMDtbl, [keyfel]:SPGUI.configFELtbl};
    let prmtypes = {[keybpf]:BPFPrmOpt(confobj), [keycmd]:CMDPrmOpt(confobj), [keyfel]:FELPrmOpt(srcobj, confobj)};
    SPGUI.srcopt.JSONObj = srcobj;

    SPGUI.confopt.JSONObj = confobj;
    SPGUI.confopt.SetValidity(conftypes[1], tbllist, prmtypes);
    document.getElementById("config_option").appendChild(SPGUI.confopt.GetTable());
    SwitchFELReuse();

    let isfgen = conftypes[1][ConfigOptionsLabel.fmateri[0]];
    let isagen = conftypes[1][ConfigOptionsLabel.amateri[0]];
    if(isfgen || isagen){
        let fid = GetIDFromItem(ConfigLabel, isfgen ? 
                ConfigOptionsLabel.fmateri[0] : 
                ConfigOptionsLabel.amateri[0]);
        let cont = document.getElementById(fid).parentNode;
        let btn = document.createElement("button");
        btn.innerHTML = "Edit Material";
        btn.addEventListener("click", (e) => {
            document.getElementById("fmaterialDialog").showModal();
        });
        let btncont = document.createElement("div");
        btncont.className = "flexcont flexright"
        btncont.appendChild(btn);
        cont.appendChild(btncont);
    }

    let fldset = document.getElementById("calcresultfld");
    let outfld = document.getElementById("outputfld");
    if(GetObj(ConfigLabel).hasOwnProperty(TypeLabel)){
        let calcid = GetCurrentCalcID();
        if(calcid.indexOf(MenuLabels.fixed) >= 0){
            fldset.classList.replace("none", "flexcont");
            outfld.classList.replace("flexcont", "none");
        }
        else if(calcid != ""){        
            fldset.classList.replace("flexcont", "none");
            outfld.classList.replace("none", "flexcont");
        }    
    }
    else{
        fldset.classList.replace("flexcont", "none");
        outfld.classList.replace("flexcont", "none");
    }

    let labels = [ConfigOptionsLabel.fcustom[0], ConfigOptionsLabel.depthdata[0], ConfigOptionsLabel.seedspec[0]];
    let items = [];
    for(let n = 0; n < labels.length; n++){
        items.push({id:GetIDFromItem(ConfigLabel, labels[n]), 
            isshow:conftypes[1][labels[n]]});
    }

    UpdateAllPlots(items);

    if(confobj[OptionLabel].hasOwnProperty(ConfigOptionsLabel.acclevel[0])){
        // "Accuracy Level" is obsolete
        let acclevel = confobj[OptionLabel][ConfigOptionsLabel.acclevel[0]];
        delete confobj[OptionLabel][ConfigOptionsLabel.acclevel[0]];
        if(acclevel == 1){
            confobj[OptionLabel][ConfigOptionsLabel.accuracy[0]] = DefaultLabel;
        }
        else{
            confobj[OptionLabel][ConfigOptionsLabel.accuracy[0]] = CustomLabel;
        }
        SPGUI.setting[AccuracyLabel] = GetAccuracyObj(acclevel);
    }
    else if(confobj.hasOwnProperty(AccuracyLabel)){
        SPGUI.setting[AccuracyLabel] = CopyJSON(confobj[AccuracyLabel]);
    }
    
    let accutypes = CustomAccuracyOpt(accobj, srcobj, confobj, SPGUI.setting[AccuracyLabel]);
    let accuobj = {};
    accuobj[OptionLabel] = SPGUI.setting[AccuracyLabel];
    SPGUI.accuracy.JSONObj = accuobj;
    SPGUI.accuracy.SetValidity(accutypes, {}, {});

    EnableEditAccuracy(confobj[OptionLabel][ConfigOptionsLabel.accuracy[0]] == CustomLabel);
    EnableEditFiltPlot(enablef || enablea);

    return indices;
}

function GetAccuracyObj(level)
{
    let accobj = CopyJSON(def_accuracy);
    let accorders =  [
        "accdisctra",
        "accinpE", 
        "acclimpE",
        "accdiscpE",
        "accineE",
        "acclimeE",
        "accinobs",
        "acclimobs",
        "accdiscobs",
        "accintime",
        "acclimtime",
        "accinsrc",
        "acclimsrc",
        "accdiscsrc",
        "accconvharm",
        "accothers"
      ];
    for(let i = 0; i < accorders.length; i++){
        accobj[AccuracyOptionsLabel[accorders[i]][0]] = level;
    }
    return accobj;
}

// functions called for options update
function UpdateAccOption(prmlabel)
{
    let indices = [];
    if(prmlabel == AccOptionsLabel.bunchtype[0]){
        let ulink = LoadAcc(true);
        indices = ulink.update;
        if(ulink.issrc){
            let srcindices = LoadSrc(false);
            Array.prototype.push.apply(indices, srcindices);
        }
        if(ulink.isconf){
            let confindices = LoadConfig(false);
            Array.prototype.push.apply(indices, confindices);
        }
    }
    LoadAccOption();
    return indices;
}

function UpdateSrcOption(prmlabel)
{
    let srcobj = GetObj(SrcLabel);
    let appleon = srcobj[TypeLabel] == SrcTypeLabel.ELLIPTIC_UND 
            && srcobj[OptionLabel][SrcOptionsLabel.apple[0]];

    let id, indices = [];
    switch(prmlabel){
        case SrcOptionsLabel.endmag[0]:
            id = GetIDFromItem(SrcLabel, SrcPrmsLabel.devlength);
            UpdatePrms(id);
            break;
        case SrcOptionsLabel.gaplink[0]:
        case SrcOptionsLabel.gaptbl[0]:
            if(appleon){
                id = GetIDFromItem(SrcLabel, SrcPrmsLabel.Kxy0);
            }
            else{
                id = GetIDFromItem(SrcLabel, SrcPrmsLabel.K);
            }
            UpdatePrms(id);
            if(prmlabel == SrcOptionsLabel.gaplink[0]){
                indices = LoadSrc(true);
            }
            break;
        case SrcOptionsLabel.apple[0]:
            SPGUI.gapfieldtable.SetSourceOption();
            SPGUI.gapfieldtable.SetBSquared();
            indices = LoadSrc(true);
            break;
        case SrcOptionsLabel.bmtandem[0]:
            indices = LoadSrc(false); // update not necessary
            break;
    }
    LoadSrcOption();
    return indices;
}

function UpdateConfigOption(prmlabel)
{
    return LoadConfig(true);
}

function LoadParallelComp()
{
    let pctypes = {};
    pctypes[PCOptionsLabel.enable[0]] = true;
    let isenable = SPGUI.setting[PCLabel][PCOptionsLabel.enable[0]] == true;
    pctypes[PCOptionsLabel.processes[0]] = isenable;
    SPGUI.pcopt.SetValidity(pctypes, {}, {});
}

function LoadFiltPlot()
{
    let filtplottypes = {};
    filtplottypes[FilterPlotOptionsLabel.filtauto[0]] = true;
    let iscust = SPGUI.setting[PlotFilterLabel][FilterPlotOptionsLabel.filtauto[0]] == CustomLabel;
    filtplottypes[FilterPlotOptionsLabel.filtemin[0]] = iscust;
    filtplottypes[FilterPlotOptionsLabel.filtemax[0]] = iscust;
    filtplottypes[FilterPlotOptionsLabel.filtpoints[0]] = iscust;
    filtplottypes[FilterPlotOptionsLabel.filtscale[0]] = iscust;
    SPGUI.filtplot.SetValidity(filtplottypes, {}, {});
}

function SetAccuracyConfig()
{
    let accobj = GetObj(AccLabel);
    let confobj = GetObj(ConfigLabel);
    let srcobj = GetObj(SrcLabel);
    let accutypes = CustomAccuracyOpt(accobj, srcobj, confobj, SPGUI.setting[AccuracyLabel]);
    SPGUI.accuracy.SetValidity(accutypes, {}, {});        
}

function UpdateOptions(id)
{
    let idc = GetItemFromID(id);

    if(idc.categ == PCLabel){
        LoadParallelComp();
        return;
    }
    else if(idc.categ == PlotFilterLabel){
        LoadFiltPlot()
        return;
    }
    else if(idc.categ == AccuracyLabel){
        if(idc.item == AccuracyOptionsLabel.acclimMCpart[0]){
            SetAccuracyConfig();
        }
        return;
    }
    else if(idc.categ == POLabel){
        return;
    }

    let prmlabel = idc.item;
    let indices = [];

    if(idc.categ == AccLabel){
        if(idc.item == AccOptionsLabel.bunchtype[0]){
            if(GetObj(AccLabel)[OptionLabel][AccOptionsLabel.bunchtype[0]] 
                == ImportPaticleLabel)
            {
                // close config and refresh acc. and src.
                GetObj(ConfigLabel)[TypeLabel] = "";
                CloseCalculation();    
                LoadAccOption();
                LoadSrcOption();
                return;
            }
        }
        indices = UpdateAccOption(prmlabel);
    }
    else if(idc.categ == SrcLabel){
        if(idc.item == SrcOptionsLabel.natfocus[0] || 
                idc.item == SrcOptionsLabel.segment_type[0] ||
                idc.item == SrcOptionsLabel.perlattice[0])
        {
            LoadAccOption();            
        }
        indices = UpdateSrcOption(prmlabel);        
    }
    else{
        let calcid = GetCurrentCalcID();
        let reusefel = IsFELReuse(calcid);
        let cmd = calcid.indexOf(MenuLabels.CMD) >= 0;
        if(idc.item == ConfigOptionsLabel.fel[0]){
            LoadAccOption();
            SwitchFELRelated();
            if(reusefel){
                RestoreOriginal();
            }
        }
        if(idc.item == ConfigOptionsLabel.CMD[0]){
            let iscmd = GetObj(ConfigLabel)[OptionLabel][ConfigOptionsLabel.CMD[0]];
            SPGUI.outputopt.ForceFormatJSON(iscmd);
        }
        if(idc.item == ConfigOptionsLabel.wiggapprox[0] || 
            idc.item == ConfigOptionsLabel.esmooth[0]){
            LoadAccOption();
        }
        indices = UpdateConfigOption(prmlabel);
        FreezeGUI(reusefel || cmd, cmd, false, reusefel);
    }
    RefreshGUIPrms(indices);
}
