"use strict";

var SPGUI = {};

function SetHeight()
{
    let winh = window.innerHeight;
    document.getElementById("pp_plot").style.height = winh.toString()+"px";
}

if(window.hasOwnProperty("__TAURI__")){
    SPGUI.runEnvironment = "tauri";
    window.__TAURI__.window.appWindow.setTitle("SPECTRA "+FullVersionNumber);
    window.__TAURI__.event.listen("message", (e) => {
        ArrangeObjects(e.payload);
    });
}
else{
    SPGUI.runEnvironment = "browser";
    document.title = "SPECTRA "+FullVersionNumber;
    window.addEventListener("message", (e) => {
        ArrangeObjects(e.data);
        setTimeout(
            function(){
                SPGUI.newplotwin.RefreshPlotObject();
            }, 100);
    });
}

window.onload = function()
{
    SetHeight();
    window.addEventListener("resize", () => {
        SetHeight();
    });    
    if(SPGUI.runEnvironment == "browser"){
        window.opener.postMessage("ready", "*");
    }
    else{
        window.__TAURI__.event.emit("ready", "");
    }
}

function ArrangeObjects(data)
{
    let pp_plot = document.getElementById("pp_plot");
    pp_plot.className = "flexcont flexcolumn flexgrow flexstretch";
    pp_plot.style.backgroundColor = "#eeeeee";

    window.resizeBy(
        data.size[0]-window.innerWidth, data.size[1]-window.innerHeight);

    let plobj = data.data;
    SPGUI.newplotwin = new PlotWindow(pp_plot, "newwin", plobj, 
            plobj.setting, plobj.plotname, plobj.frameindices, plobj.tinv);
}
